<?php
/*
Plugin Name: gSlideShow
Plugin URI: http://www.phtagr.org/
Description: This slideshow widget plugin loads a media rss and displays a javascript slide show using google's AJAX Feed API Slide Show Control. The plugin is based on the plugin FlickrRSS 4.0.
Version: 0.1
License: GPL
Author: xemle
Author URI: http://www.phtagr.org
*/

function get_gSlideShow() {
  $rss = get_option('gSlideShow_rss');
  if (!$rss) {
  	$rss = 'http://www.google.com/uds/solutions/slideshow/sample.rss';
  }
  $display_time = get_option('gSlideShow_display_time');
  if (!$display_time) {
  	$display_time = 2000;
  }
  $transistion_time = get_option('gSlideShow_transistion_time');
  if (!$transistion_time) {
  	$transistion_time = 500;
  }

  if ($rss) {
  	// see http://www.google.com/uds/solutions/slideshow/reference.html
  	echo "<p><script src='http://www.google.com/jsapi' type='text/javascript'></script>
  	<script src='http://www.google.com/uds/solutions/slideshow/gfslideshow.js' type='text/javascript'></script>
  	<style type='text/css'>
  		.gss a img {
  			border : none;
  		}
  		.gss {
  			width: 180px;
  			height: 180px;
  			color: #dddddd;
  			background-color: #fff;
  			padding: 5px;
  			border: 1px solid #eee;
  		}
  	</style>
  	<script type='text/javascript'>
  		function load() {
  			var samples = '$rss';
  			var options = {
  				displayTime: $display_time,
  				transistionTime: $transistion_time,
  				scaleImages: true,
  				fullControlPanel: true,
  				linkTarget: google.feeds.LINK_TARGET_BLANK
  			};
  			new GFslideShow(samples, 'slideshow', options);
  		}
  		google.load('feeds', '1');
  		google.setOnLoadCallback(load);
  	</script>
  	<div id='slideshow' class='gss'>Loading...</div>
  </p>";
  } else {
  	echo "<p>No media feed defind</p>";
  }
}

function widget_gSlideShow_init() {
  if (!function_exists('register_sidebar_widget')) {
  	return;
  }

  function widget_gSlideShow($args) {
  	extract($args);

  	$options = get_option('widget_gslideshow');
  	$title = isset($options['title']) && $options['title'] ? $options['title'] : 'Slide Show';

  	echo $before_widget.$before_title.$title.$after_title;
  	get_gSlideShow();
  	echo $after_widget;
  }

  function widget_gSlideShow_control() {
  	$options = get_option('widget_gslideshow');

  	if ($_POST['gSlideShow-submit']) {
  		$options['title'] = stripslashes($_POST['gSlideShow-title']);
  		update_option('widget_gslideshow', $options);
  	}

  	$title = htmlspecialchars($options['title'], ENT_QUOTES);
  	
  	echo '<p style="text-align:right;"><label for="gSlideShow-title">Title: <input style="width: 180px;" id="gSlideShow-title" name="gSlideShow-title" type="text" value="'.$title.'" /></label></p>';
  	echo '<input type="hidden" id="gSlideShow-submit" name="gSlideShow-submit" value="1" />';
  }    

  register_sidebar_widget('gSlideShow', 'widget_gSlideShow');
  register_widget_control('gSlideShow', 'widget_gSlideShow_control');
}

function gSlideShow_subpanel() {
  if (isset($_POST['save_gSlideShow_settings'])) {
  	$rss = $_POST['rss'];
  	$display_time = intval($_POST['display_time']);
  	if ($display_time < 500) {
  		$display_time = 500;
  	}
  	$transistion_time = intval($_POST['transistion_time']);
  	if ($display_time < 0) {
  		$display_time = 0;
  	}

  	update_option('gSlideShow_rss', $rss);
  	update_option('gSlideShow_display_time', $display_time);
  	update_option('gSlideShow_transistion_time', $transistion_time);
  	?><div class="updated"><p>gSlideShow settings saved</p></div><?php
  }
  ?>

  <div class="wrap">
  	<h2>gSlideShow Settings</h2>
  	<form method="post">
  	<table class="form-table">
  		<tr valign="top">
  			<th scope="row">Media RSS</th>
  			<td><input name="rss" type="text" id="rss_id" value="<?php echo get_option('gSlideShow_rss'); ?>" size="20" /></td>
  		</tr>
  		<tr valign="top">
  			<th scope="row">Display Time</th>
  			<td><input name="display_time" type="text" id="display_time_id" value="<?php echo get_option('gSlideShow_display_time'); ?>" size="20" /></td>
  		</tr>
  		<tr valign="top">
  			<th scope="row">Transistion Time</th>
  			<td><input name="transistion_time" type="text" id="transistion_time_id" value="<?php echo get_option('gSlideShow_transistion_time'); ?>" size="20" /></td>
  		</tr>
  	</table>
  	<div class="submit">
  		<input type="submit" name="save_gSlideShow_settings" value="<?php _e('Save Settings', 'save_gSlideShow_settings') ?>" />
  	</div>
  	</form>
  </div>

<?php } // end gSlideShow_subpanel()

function gSlideShow_admin_menu() {
  if (function_exists('add_options_page')) {
  	add_options_page('gSlideShow Settings', 'gSlideShow', 8, basename(__FILE__), 'gSlideShow_subpanel');
  }
}

add_action('admin_menu', 'gSlideShow_admin_menu'); 
add_action('plugins_loaded', 'widget_gSlideShow_init');
?>
